## atlas 3.8.4

=== CONFIG/ARCHS/Makefile ===
include ../Make.inc
arch=$(ARCH)
mach=$(ARCH)
dcc=default
cc=gcc
skc=$(skcD)
dkc=$(dkcD)
smc=$(smcD)
dmc=$(dmcD)
comps = skc=$(skc) dkc=$(dkc) smc=$(smc) dmc=$(dmc)

adefd = $(BLDdir)/ARCHS/$(mach)

tarfile : $(mach)
	- rm $(mach).tgz $(mach).tar
	tar cvf $(mach).tar $(mach)
	gzip --best $(mach).tar
	mv $(mach).tar.gz $(mach).tgz

$(mach)/kern/$(dcc) :
	mkdir $(mach)/kern/$(dcc)
$(mach)/gemm/$(dcc) :
	mkdir $(mach)/gemm/$(dcc)

$(mach) :
	mkdir $(mach)
	mkdir $(mach)/kern $(mach)/gemm
	$(MAKE) $(mach)/kern/$(skc) dcc=$(skc)
	$(MAKE) $(mach)/kern/$(dkc) dcc=$(dkc)
	$(MAKE) $(mach)/gemm/$(smc) dcc=$(smc)
	$(MAKE) $(mach)/gemm/$(dmc) dcc=$(dmc)

xnegflt : $(SRCdir)/CONFIG/ARCHS/negflt.c
	gcc -O -o xnegflt $(SRCdir)/CONFIG/ARCHS/negflt.c

ssys_put:
	- cp $(adefd)/kern/sMULADD $(SYSdir)/res/.
	- cp $(adefd)/kern/L1CacheSize $(SYSdir)/res/.
ssys :
	- cp $(SYSdir)/res/sMULADD $(adefd)/kern/.
	./xnegflt $(adefd)/kern/sMULADD
	- cp $(SYSdir)/res/L1CacheSize $(adefd)/kern/.
skern_put:
	- cp $(adefd)/kern/$(skc)/[s,c]TRSM_NB $(BLDdir)/tune/blas/level3/res/.
	- cp $(adefd)/kern/$(skc)/[s,c]MVRES $(BLDdir)/tune/blas/gemv/res/.
	- cp  $(adefd)/kern/$(skc)/[s,c]R1RES $(BLDdir)/tune/blas/ger/res/.
	- cp $(adefd)/kern/$(skc)/[s,c]*_SUMM $(L1Tdir)/res/.
skern: xnegflt
	rm -f $(adefd)/kern/$(skc)/[s,c]*
	- cp $(BLDdir)/tune/blas/level3/res/[s,c]TRSM_NB $(adefd)/kern/$(skc)/.
	- cp $(BLDdir)/tune/blas/gemv/res/[s,c]MVRES $(adefd)/kern/$(skc)/.
	- cp $(BLDdir)/tune/blas/ger/res/[s,c]R1RES $(adefd)/kern/$(skc)/.
	./xnegflt $(adefd)/kern/$(skc)/[s,c]R1RES \
                  $(adefd)/kern/$(skc)/[s,c]MVRES
	- cp $(L1Tdir)/res/[s,c]*_SUMM $(adefd)/kern/$(skc)/.
sgemm_put:
	- cp $(adefd)/gemm/$(smc)/[s,c]MMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]gMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Clean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]best[N,T][N,T]_* $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uClean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uClean[M,N,K]F $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]nreg $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]NB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]NCNB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Xover.h $(INCAdir)/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Xover.h $(MMTdir)/res/.
sgemm: xnegflt
	rm -f $(adefd)/gemm/$(smc)/[s,c]*
	- cp $(MMTdir)/res/[s,c]MMRES $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]gMMRES $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]Clean[M,N,K] $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]best[N,T][N,T]_* $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uMMRES $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uClean[M,N,K] $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uClean[M,N,K]F $(adefd)/gemm/$(smc)/.
	./xnegflt $(adefd)/gemm/$(smc)/*
	- cp $(MMTdir)/res/[s,c]nreg $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]NB $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]NCNB $(adefd)/gemm/$(smc)/.
	- cp $(INCAdir)/[s,c]Xover.h $(adefd)/gemm/$(smc)/.
dsys_put:
	- cp $(adefd)/kern/dMULADD $(SYSdir)/res/.
	- cp $(adefd)/kern/L1CacheSize $(SYSdir)/res/.
dsys :
	- cp $(SYSdir)/res/dMULADD $(adefd)/kern/.
	./xnegflt $(adefd)/kern/dMULADD
	- cp $(SYSdir)/res/L1CacheSize $(adefd)/kern/.
dkern_put:
	- cp $(adefd)/kern/$(dkc)/[d,z]TRSM_NB $(BLDdir)/tune/blas/level3/res/.
	- cp $(adefd)/kern/$(dkc)/[d,z]MVRES $(BLDdir)/tune/blas/gemv/res/.
	- cp  $(adefd)/kern/$(dkc)/[d,z]R1RES $(BLDdir)/tune/blas/ger/res/.
	- cp $(adefd)/kern/$(dkc)/[d,z]*_SUMM $(L1Tdir)/res/.
dkern: xnegflt
	rm -f $(adefd)/kern/$(dkc)/[d,z]*
	- cp $(BLDdir)/tune/blas/level3/res/[d,z]TRSM_NB $(adefd)/kern/$(dkc)/.
	- cp $(BLDdir)/tune/blas/gemv/res/[d,z]MVRES $(adefd)/kern/$(dkc)/.
	- cp $(BLDdir)/tune/blas/ger/res/[d,z]R1RES $(adefd)/kern/$(dkc)/.
	./xnegflt $(adefd)/kern/$(dkc)/[d,z]R1RES \
                  $(adefd)/kern/$(dkc)/[d,z]MVRES
	- cp $(L1Tdir)/res/[d,z]*_SUMM $(adefd)/kern/$(dkc)/.
dgemm_put:
	- cp $(adefd)/gemm/$(dmc)/[d,z]MMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]gMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Clean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]best[N,T][N,T]_* $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uClean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uClean[M,N,K]F $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]nreg $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]NB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]NCNB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Xover.h $(INCAdir)/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Xover.h $(MMTdir)/res/.
dgemm: xnegflt
	rm -f $(adefd)/gemm/$(dmc)/[d,z]*
	- cp $(MMTdir)/res/[d,z]MMRES $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]gMMRES $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]Clean[M,N,K] $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]best[N,T][N,T]_* $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uMMRES $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uClean[M,N,K] $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uClean[M,N,K]F $(adefd)/gemm/$(dmc)/.
	./xnegflt $(adefd)/gemm/$(dmc)/*
	- cp $(MMTdir)/res/[d,z]nreg $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]NB $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]NCNB $(adefd)/gemm/$(dmc)/.
	- cp $(INCAdir)/[d,z]Xover.h $(adefd)/gemm/$(dmc)/.
sys_put : ssys_put dsys_put
kern_put : skern_put dkern_put
gemm_put : sgemm_put dgemm_put
	- cp $(adefd)/gemm/atlas_cacheedge.h $(INCAdir)/.
	- cp $(adefd)/gemm/atlas_??NKB.h $(INCAdir)/.
sys : ssys dsys
kern : skern dkern
gemm : sgemm dgemm
	- cp $(INCAdir)/atlas_cacheedge.h $(adefd)/gemm/
	- cp $(INCAdir)/atlas_??NKB.h $(adefd)/gemm/
ArchNew : $(mach) xnegflt
	$(MAKE) sys kern gemm
	- cp $(BLDdir)/bin/INSTALL_LOG/?PerfSumm.txt $(adefd)/.
	rm -f xnegflt
archput : sys_put kern_put gemm_put

=== debian/changelog ===
atlas (3.8.4-9ubuntu1) raring; urgency=low

  * Merge from Debian unstable (LP: #1069761). Remaining Changes:
    - debian/rules:
      - Add "-Si cputhrchk 0" back to config flags because some of the
        Ubuntu build servers have throttling enabled (i386 and amd64).
        Fixes FTBFS on those platforms.

 -- Vibhav Pant <vibhavp@gmail.com>  Mon, 05 Nov 2012 23:27:22 +0100

atlas (3.8.4-9) unstable; urgency=low

  [ Sébastien Villemot ]
  * libatlas-test: put in devel/extra, to reflect override
  * Force generic PPC CPU when building a non-custom package on a PPC arch
    (Closes: #680096)

  [ Sylvestre Ledru ]
  * Use series for list the patches
  * Patches refreshed

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Sat, 04 Aug 2012 11:56:20 +0000

atlas (3.8.4-8ubuntu1) quantal; urgency=low

  * debian/rules:
    - Add "-Si cputhrchk 0" back to config flags because some of the
      Ubuntu build servers have throttling enabled (i386 and amd64).
      Fixes FTBFS on those platforms.

 -- Michael Terry <mterry@ubuntu.com>  Wed, 25 Jul 2012 14:43:03 -0400

atlas (3.8.4-8) unstable; urgency=low

  * libatlas3-base.prerm, libatlas3gf-base.prerm: avoid crash if libblas.so.3gf
    or liblapack.so.3gf already deleted
  * Add 3gf compat symlinks for libcblas, libf77blas and liblapack_atlas
    (to avoid breakage of some reverse deps)
  * In the LAPACK alternatives, use a lower priority than Netlib (in order to
    minimize the incidence of #576972)  
  * Update and clean-up README.Debian
  * Mention known build failures in README.source
  * libatlas3gf-base transitional package:
    + move to section oldlibs
    + mark as arch:all
  * Add myself to Uploaders
  * Set DM-Upload-Allowed to yes

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Sun, 24 Jun 2012 15:36:49 +0000

atlas (3.8.4-7) unstable; urgency=low

  * Force generic x86 CPU when building a non-custom package on an x86 arch
    (Closes: #676885)
  * Force 2 threads when not building a custom package (as was the case up
    to and including 3.8.3-30)
  * Fix detection of some Intel Core i1 CPUs (corei1.diff)

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Wed, 13 Jun 2012 16:33:20 +0200

atlas (3.8.4-6) unstable; urgency=low

  * Yet an other stupid bug... 
    Merci à Rafael Laboissiere (Closes: #676614)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 08 Jun 2012 20:16:49 +0200

atlas (3.8.4-5) unstable; urgency=low

  * Bring back slave alternative for liblapack.so.3gf.
    Merci à Sébastien Villemot (Closes: #676495)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 07 Jun 2012 13:02:23 +0200

atlas (3.8.4-4) unstable; urgency=low

  * Upload in unstable (Closes: #673357)
 
 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Jun 2012 17:33:13 +0200

atlas (3.8.4-4~exp9) experimental; urgency=low

  * Drop the old conflict on libblas-3.so

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 31 May 2012 19:55:12 +0200

atlas (3.8.4-4~exp8) experimental; urgency=low

  * Replaces and Breaks updated against the right versions of other impacted
    packages
  * Force the right version to build against liblapack-dev and libblas-dev
  * Add a missing conflict

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 22 May 2012 14:32:20 +0200

atlas (3.8.4-4~exp7) experimental; urgency=low

  * Fix a mixed between postinst & preinst (Closes: #643767)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 20 May 2012 17:21:33 +0200

atlas (3.8.4-4~exp6) experimental; urgency=low

  * Moved removal from postinst to preinst

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 18 May 2012 16:06:24 +0200

atlas (3.8.4-4~exp5) experimental; urgency=low

  * libblas and liblapack were not correctly named causing upgrades to fails.
    (Closes: #643767)
  * Update the README.Debian and TODO regarding recent changes

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 15 May 2012 18:06:16 +0200

atlas (3.8.4-4~exp4) experimental; urgency=low

  * Remove libblas.so.3gf liblapack.so.3gf references before the install
  * Fix a typo in the CPU freq (Closes: #672783)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 18 May 2012 16:06:16 +0200

atlas (3.8.4-4~exp3) experimental; urgency=low

  * Update standards version to version 3.9.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 10 Apr 2012 22:01:50 +0200

atlas (3.8.4-4~exp2) experimental; urgency=low

  * Join modifications with blas, lapack, atlas and openblas.
    Declare the replacements of all *3gf blas & lapack implementation
    (See bug #660607)
  * postinst-has-useless-call-to-ldconfig & postrm-has-useless-call-to-ldconfig
    fixed
  * copyright-refers-to-deprecated-bsd-license-file fixed
  * libatlas3gf-base is now a transitional package to libatlas3-base
  * Fix a FTBFS under sh4. Thanks to Nobuhiro Iwamatsu for the patch
    (Closes: #605650)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 20 Feb 2012 18:58:04 +0100

atlas (3.8.4-4~exp1) experimental; urgency=low

  * Rename libblas3gf package => libblas3
  * Rename libblas.so.3gf => libblas.so.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 04 Sep 2011 14:47:41 +0200

atlas (3.8.4-3) unstable; urgency=low

  * Revert change about devscripts being in the build-dep (see bug #628104)
  * Fix an error about missing tests when building custom package
    (Closes: #629528)
  * Fix an error about the pdf which cannot be found when building custom
    package.

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 07 Jun 2011 20:56:49 +0200

atlas (3.8.4-2) unstable; urgency=low

  * Fix the FTBFS under kfreebsd (kfreebsd.diff) (Closes: #628424)
  * Update of the README.Ddebian with more information
  * devscripts added into the build-dep of atlas (Closes: #628104)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 30 May 2011 23:58:17 +0200

atlas (3.8.4-1) unstable; urgency=low

  * New upstream release
  * force -j 1 of make removed (hopefully fixes the FTBFS)
  * -Si cputhrchk 0 removed
  * Standards-Version updated to version 3.9.2


=== debian/control ===
Source: atlas
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>,
           Sébastien Villemot <sebastien.villemot@ens.fr>
DM-Upload-Allowed: yes
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 7), patch, gfortran, cdbs,
 libblas-dev  (>= 1.2.20110419-3),
 liblapack-dev (>= 3.4.1-1), liblapack-pic (>= 3.4.1-1), libblas-test,
 texlive-latex-base, ghostscript, cpufrequtils
Homepage: http://math-atlas.sourceforge.net/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/atlas/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/atlas/

Package: libatlas3-base
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libatlas.so.3gf, libblas.so.3gf, liblapack.so.3gf,
 libatlas.so.3, libblas.so.3, liblapack.so.3
Conflicts: atlas2 (<< 3.2.1-1), libblas3gf (<< 1.2-5), 
 liblapack3gf (<< 3.2.1-4), libatlas3gf-sse (<< 3.8.3-25), 
 libatlas3gf-sse2 (<< 3.8.3-25), libatlas3gf-sse3 (<< 3.8.3-25), 
 libatlas3gf-core2sse3 (<< 3.8.3-25), libatlas3gf-amd64sse3 (<< 3.8.3-25),
 libatlas3gf-corei7sse3 (<< 3.8.3-25), libatlas3gf-altivec (<< 3.8.3-25), 
 libatlas3gf-v9 (<< 3.8.3-25), libatlas3gf-ev6 (<< 3.8.3-25), 
 libatlas3gf-2.0 (<< 3.8.3-25), libatlas3gf-base (<< 3.8.4-4)
Replaces: atlas2 (<< 3.2.1-1),  libatlas3gf-sse (<< 3.8.3-25), 
 libatlas3gf-sse2 (<< 3.8.3-25), libatlas3gf-sse3 (<< 3.8.3-25), 
 libatlas3gf-core2sse3 (<< 3.8.3-25), libatlas3gf-amd64sse3 (<< 3.8.3-25),
 libatlas3gf-corei7sse3 (<< 3.8.3-25), libatlas3gf-altivec (<< 3.8.3-25), 
 libatlas3gf-v9 (<< 3.8.3-25), libatlas3gf-ev6 (<< 3.8.3-25), 
 libatlas3gf-2.0 (<< 3.8.3-25), libblas3gf (<< 1.2.20110419-3),
 libatlas3gf-base (<< 3.8.4-4), libopenblas-base (<< 0.1.1-3),
 liblapack3gf (<< 3.4.0-1)
Breaks: libblas3gf (<< 1.2.20110419-3), libatlas3gf-base (<< 3.8.4-4),
 libopenblas-base (<< 0.1.1-3),  liblapack3gf (<< 3.4.0-1)
Suggests: liblapack3
Description: Automatically Tuned Linear Algebra Software, generic shared
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 The libraries in this package are built without any processor extension
 instructions, and should run on all processors of this general
 architecture, albeit less than optimally.  
 . 
 Before version 3.8.3-25, optimized binary packages were provided.
 However, due to the fact that most Atlas optimisation are done at build time,
 it has been decided to remove them and give priority to locally built packages.
 . 
 For more information on how to rebuild locally atlas, see the section:
 "Building Optimized Atlas Packages on your ARCH" in README.Debian

Package: libatlas3gf-base
Section: oldlibs
Architecture: all
Depends: ${misc:Depends}, libatlas3-base
Description: Transitional package to libatlas3-base
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.

Package: libatlas-base-dev
Section: libdevel
Architecture: any
Depends: libatlas3-base (= ${binary:Version}), libatlas-dev, ${misc:Depends}, 
 ${shlibs:Depends}
Provides: libatlas-3gf.so, libblas-3gf.so, liblapack-3gf.so,
 libatlas-3.so, liblapack-3.so
Conflicts: atlas2-dev (<< 3.2.1-3), atlas2-base-dev, libblas-dev (<< 1.2-5), 
 liblapack-dev (<< 3.2.1-4), libatlas-sse-dev (<< 3.8.3-25), 
 libatlas-sse2-dev (<< 3.8.3-25), libatlas-sse3-dev (<< 3.8.3-25), 
 libatlas-core2sse3-dev (<< 3.8.3-25), libatlas-amd64sse3-dev (<< 3.8.3-25),
 libatlas-corei7sse3-dev (<< 3.8.3-25), libatlas-altivec-dev (<< 3.8.3-25), 
 libatlas-v9-dev (<< 3.8.3-25), libatlas-ev6-dev (<< 3.8.3-25), 
 libatlas-2.0-dev (<< 3.8.3-25)
Replaces: atlas2-dev (<< 3.2.1-3), atlas2-base-dev, libatlas-sse-dev, 
 libatlas-sse-dev (<< 3.8.3-25), 
 libatlas-sse2-dev (<< 3.8.3-25), libatlas-sse3-dev (<< 3.8.3-25), 
 libatlas-core2sse3-dev (<< 3.8.3-25), libatlas-amd64sse3-dev (<< 3.8.3-25),
 libatlas-corei7sse3-dev (<< 3.8.3-25), libatlas-altivec-dev (<< 3.8.3-25), 
 libatlas-v9-dev (<< 3.8.3-25), libatlas-ev6-dev (<< 3.8.3-25), 
 libatlas-2.0-dev (<< 3.8.3-25)
Suggests: libblas-doc, liblapack-doc
Description: Automatically Tuned Linear Algebra Software, generic static
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package includes the static libraries and symbolic links
 needed for program development.

Package: libatlas-dev
Section: libdevel
Architecture: all
Depends: libc6-dev, libblas-dev, ${misc:Depends}, ${shlibs:Depends}
Conflicts: atlas-dev, atlas2-dev (<< 3.2.1-3), atlas2-headers, atlas3-headers,
 libblas-dev (<< 1.2-5), liblapack-dev (<< 3.2.1-4)
Replaces: atlas2-dev (<< 3.2.1-3), atlas2-headers, atlas3-headers
Suggests: liblapack-dev, liblapack-doc
Description: Automatically Tuned Linear Algebra Software, C header files
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides the headers needed to compile against the libraries
 provided by ATLAS.

Package: libatlas-test
Architecture: any
Section: devel
Priority: extra
Replaces: atlas-test, atlas3-test
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: liblapack3
Description: Automatically Tuned Linear Algebra Software, test programs
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides dynamically linked testing and bench-marking
 binaries to compare the blas and atlas libraries on your system.

Package: libatlas-doc
Section: doc
Depends: ${misc:Depends}
Conflicts: atlas-doc, atlas3-doc
Replaces: atlas-doc, atlas3-doc
Architecture: all
Description: Automatically Tuned Linear Algebra Software, documentation
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides documentation on the atlas libraries useful for
 developers.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright 2008-2010 Sylvestre Ledru <sylvestre@debian.org>

include /usr/share/cdbs/1/rules/debhelper.mk

DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)
DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Pointer bitwidth (default value)
MODE_BITWIDTH = 32

# First number in ARCHS:
# - 0 means Unknown CPU. Leave Atlas find out
# - 1 means POWER3, most generic PowerPC (see #680096)
# - 26 means Generic x86 CPU
# Second number in ARCHS:
# - 1 means no instruction set extension
X86_ARCHS := amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-i386
PPC_ARCHS := powerpc powerpcspe ppc64
ifneq (,$(findstring $(DEB_HOST_ARCH),$(X86_ARCHS)))
ARCHS=base_26_1
else ifneq (,$(findstring $(DEB_HOST_ARCH),$(PPC_ARCHS)))
ARCHS=base_1_1
else
ARCHS=base_0_1
endif

DEB_SHLIBDEPS_INCLUDE_libatlas3-base := $(CURDIR)/debian/libatlas3-base/usr/lib/atlas-base/:$(CURDIR)/debian/libatlas3-base/usr/lib/atlas-base/atlas/

# # see what do we do with the amd64 / intel 64
ifeq ($(DEB_HOST_ARCH_CPU),amd64)
# # 64 bits
MODE_BITWIDTH = 64
endif

ifeq ($(DEB_HOST_ARCH_CPU),ia64)
MODE_BITWIDTH = 64
endif

ifeq ($(DEB_HOST_ARCH_CPU),ppc64)
# Power PC 64
MODE_BITWIDTH = 64
endif

GFORTRAN_LIB_PATH=`gcc -print-search-dirs|grep ^install:|awk '{print $$2}'`

COMMON_CONFIG_PARAMS := --prefix="$(DEB_DESTDIR)" 	\
	--incdir="$(DEB_DESTDIR)/usr/include/"			\
	--libdir="$(DEB_DESTDIR)/usr/lib/$$targetName"		\
	--cc="${CC}" 									\
	--cflags="${CFLAGS}" 							\
	-D c -DWALL 									\
	-b $(MODE_BITWIDTH) 							\
	-Fa alg '-Wa,--noexecstack -fPIC' 				\
	-Ss f77lib "-L$(GFORTRAN_LIB_PATH) -lgfortran -lgcc_s -lpthread"  \
	-Ss pmake '$(MAKE)'					\
	-Si cputhrchk 0                 \
	--with-netlib-lapack=/usr/lib/liblapack_pic.a 	\
	-A $$atlasArch									\
	-V $$atlasISA 									\
	-v 2
# ../../configure --cc="cc" --cflags="-g -O2" -D c -DWALL -b 64 -Fa alg '-Wa,--noexecstack -fPIC' -Ss flapack /usr/lib/liblapack_pic.a -Ss f77lib "-L/usr/lib/gcc/x86_64-linux-gnu/4.4.5/ -lgfortran -lgcc_s -lpthread" -Ss pmake '/usr/bin/make -j 1' -A 0 -V 1 -v 2 -Si cputhrchk 0 -t 2
custom: custom-stamp

# Build a custom package optimized for the current arch
custom-stamp:
		rm -f configure-stamp

		ncpu=$$(LANG=C cpufreq-info | grep "analyzing CPU" -c);\
		cpu=0;\
		while test $$cpu -lt $$ncpu ; do\
		if test $$(cpufreq-info -p 2>&1 > /dev/null; echo $$?) \
			-eq 0 -a -z "$$(LANG=C cpufreq-info -p -c $$cpu | grep performance)" ; then \
			echo "frequency governor on cpu=$$cpu is not set to 'performance'"; \
			echo "run: 'sudo cpufreq-set -g performance -c cpu#' for each cpu"; \
			echo "aborting atlas build"; \
			exit 1; \
		fi; \
		cpu=$$((cpu+1)) ;\
		done

		# Here, the trick is pretty simple:
		# * We don't want to build all the optimized version of Atlas. Just the
		#   one for the current CPU
		# * We override ARCHS by base__
		# * Base is the name of the package (libatlas3-base)
		# * __ is provided to have the right expression
		# * the regexp will consider that atlasArch and atlasISA are empty
		#   therefor, leaving the choice of the optimization to Atlas
		# * After that, we fall back to the normal build procedure by calling
		#   debian/rules itself (yep, recursively)

		# Remove all the other archs in this case
		dch --local='+custom'  "custom build on: `uname -a`"
		LANG=C debian/rules ARCHS=base__ binary
		touch $@

configure-stamp:
		dh_testdir

		set -e;											\
		targetName=`echo $(ARCHS)|sed -e "s|\(.*\)_.*_.*|atlas-\1|g"`; \
		atlasArch=`echo $(ARCHS)|sed -e "s|.*_\(.*\)_.*|\1|g"`; \
		atlasISA=`echo $(ARCHS)|sed -e "s|.*_.*_\(.*\)|\1|g"`; \
		mkdir -p build/$$targetName;					\
		cd build/$$targetName; 							\
		if test "$(ARCHS)" != "base__"; then 		\
		../../configure $(COMMON_CONFIG_PARAMS) -t 2;	\
		else						\
		../../configure $(COMMON_CONFIG_PARAMS);	\
		fi;						\
		echo "Configure done. targetName = $$targetName / atlasArch = $$atlasArch / atlasISA = $$atlasISA";								\
		if test ! -s Make.inc; then echo "Configure failed: Make.inc not found"; exit 1; fi;											\
		cat Make.inc |grep ARCH|head -1|awk '{print $$3}'; \
		echo "=============================================="; \
		cd -
		touch $@


build: build-arch build-indep

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
		touch $@

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
		dh_testdir
		set -e; 												\
		targetName=`echo $(ARCHS)|sed -e "s|\(.*\)_.*_.*|atlas-\1|g"`; \
		cd build/$$targetName;									\
		$(MAKE) build;											\
		cd lib;													\
		$(MAKE) shared;											\
		$(MAKE) ptshared;										\
		cd ..;													\
		$(MAKE) check;											\
		$(MAKE) ptcheck;										\
		echo "==============================================";	\
		cd ../../../
		# Do not build the help when building the custom package
		if test "$(ARCHS)" != "base__"; then \
			make -C TexDoc atlas_contrib.pdf atlas_devel.pdf atlas_install.pdf cblasqref.pdf  f77blasqref.pdf lapackqref.pdf; \
		fi
		touch $@

clean:: clean-work #unpatch
clean-work:
		dh_testdir
		dh_testroot
		rm -rf build check 
		rm -f build-arch-stamp build-indep-stamp
		rm -f install-arch-stamp install-indep-stamp configure-stamp

		[ ! -f Makefile ] || $(MAKE) distclean
		# some additional cleanups
		dh_clean 


install: install-arch install-indep

install-indep: configure build install-indep-stamp
install-indep-stamp:
		dh_testdir
		dh_testroot
		dh_installdirs -i

install-arch: configure build  install-arch-stamp
install-arch-stamp:
		dh_testdir
		dh_testroot

		set -e;													\
		targetName=`echo $(ARCHS)|sed -e "s|\(.*\)_.*_.*|atlas-\1|g"`; \
		cd build/$$targetName;									\
		echo "make install of $$targetName to $(DEB_DESTDIR)";	\
		$(MAKE) DESTDIR=$(DEB_DESTDIR) install;					\
		echo "=============================================";	\
		cd -

install/libatlas-dev::
	if test -d $(CURDIR)/debian/libatlas-dev/usr/include/; then \
		rm -rf $(CURDIR)/debian/libatlas-dev/usr/include/;  \
	fi
	mkdir -p $(CURDIR)/debian/libatlas-dev/usr/include/
	mv $(CURDIR)/debian/tmp/usr/include/*.h $(CURDIR)/debian/tmp/usr/include/atlas/
	mv $(CURDIR)/debian/tmp/usr/include/atlas $(CURDIR)/debian/libatlas-dev/usr/include/

install/libatlas-doc::
	if test "$(ARCHS)" != "base__"; then \
		mkdir -p $(CURDIR)/debian/libatlas-doc/usr/share/doc/libatlas-doc/; \
		cp -R $(CURDIR)/doc/* $(CURDIR)/TexDoc/*.pdf $(CURDIR)/debian/libatlas-doc/usr/share/doc/libatlas-doc/; \
	fi

binary: binary-indep binary-arch

binary-indep: build install
		dh_testdir -i
		dh_testroot -i
		dh_installchangelogs  -i
#		dh_installexamples -patlas-doc examples/*
		dh_installman -i
		dh_link -i
		dh_strip -i
		dh_compress  -i -X.pdf
		dh_fixperms -i
		dh_makeshlibs -i -n
		dh_installdeb -i
		dh_shlibdeps -i -l $$(pwd)
#		dh_shlibdeps -i
		dh_gencontrol -i
		dh_md5sums -i
		dh_builddeb -i

binary-arch: build install
		dh_testdir -a
		dh_testroot -a
		dh_installchangelogs  -a
		dh_installexamples -a
		dh_installman -a
		dh_link -a
		dh_compress  -a
		dh_fixperms -a
		dh_installdeb -a

.PHONY: build build-indep build-indep-stamp build-arch build-arch-stamp check clean binary binary-indep binary-arch configure-stamp configure custom custom-stamp


get-orig-source:
	-uscan --upstream-version 0
